<?php

namespace Management\Controllers;

use Zeedhi\Framework\DataSource\DataSet;

class Session {
    private $environment;

    public function __construct($crudService, $environment) {
		$this->crudService = $crudService;
        $this->environment = $environment;
    }

    public function startSession($request, $response) {

		$user = $request->getRow();
		$this->environment->setCdFilial($user['cdfilialselecionada']);
		$this->environment->setCdOperador($user['cdoperador']);
        $this->environment->setNrOrgTrab($user['nrorg']);
        $this->environment->setNrOrg($user['nrorg']);
        
    
		$paramgeralDataSet = $this->getParamgeral();
		$paramfilialDataSet = $this->getParamfilial();
		$paramoperadorDataSet = $this->getParamOperador();
		
		$paramoperador = $paramoperadorDataSet->getRows();
		$paramgeral = $paramgeralDataSet->getRows();
		$idutildtproc = isset($paramgeral[0]) && isset($paramgeral[0]["IDUTILDTPROC"]) ? $paramgeral[0]["IDUTILDTPROC"] : 'N';
		$paramfilial = $paramfilialDataSet->getRows();
		$currentDate = date("d/m/Y 00:00:00");
		if (!empty($paramfilial)) {
			$dtprocessa = isset($paramfilial[0]["DTPROCESSA"]) ? $paramfilial[0]["DTPROCESSA"] : $currentDate;
			$dtprocessa = $idutildtproc == 'S' ? $dtprocessa : $currentDate;
			$paramfilial[0]["DTPROCESSA"] = $dtprocessa;
			$paramfilial[0]["IDUTLPERFILFILIAL"] = $this->environment->getIdUtlPerfilFilial();
			$paramoperador[0]["NRPERFILSELECIONADO"] = $this->environment->getNrPerfil();
		} else {
			$paramfilial = array();
		}
		$paramfilialDataSet = new DataSet("paramfilial", $paramfilial);
		$paramoperadorDataSet = new DataSet("paramoperador", $paramoperador);
		
		$filialDataSet = self::getCentralCompras();
		
		$response->addDataSet($paramgeralDataSet);
		$response->addDataSet($paramfilialDataSet);
		$response->addDataSet($filialDataSet);
		$response->addDataSet($paramoperadorDataSet);
		
	}
	
	private function getCentralCompras() {
		$filialLogada = $this->environment->getCdFilial();
		
		if($filialLogada) {
			$filial = $this->getFilial($filialLogada)->getRows();
		
			if(count($filial) > 0) { 
				if(!$filial[0]['CDFILCENTCMP'] ) {
					$filial[0] = array('CDFILCENTCMP' => $filialLogada);
				}
			} else {
				$filial = array();
				$filial[0] = array('CDFILCENTCMP' => $filialLogada);
			}
		} else {
			$filial = array();
		}
		
		return new DataSet("filial", $filial);
	}

	private function getParamgeral() {
		$conditions = array(
			array(
				"columnName" => "NRORG",
				"operator" => "=",
				"value" => $this->environment->getNrOrg()
			)
		);
		return $this->crudService->getFilteredDataSet("paramgeral", $conditions);
	}

	private function getParamfilial() {
		$conditions = array(
			array(
				"columnName" => "NRORG",
				"operator" => "=",
				"value" => $this->environment->getNrOrg()
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $this->environment->getCdFilial()
			)
		);
		return $this->crudService->getFilteredDataSet("paramfilial", $conditions);
	}

	private function getFilial($cdfilial) {
		$conditions = array(
			array(
				"columnName" => "NRORG",
				"operator" => "=",
				"value" => $this->environment->getNrOrg()
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $cdfilial
			)
		);
		return $this->crudService->getFilteredDataSet("filial", $conditions);
	}
	
	private function getParamOperador() {
		$conditions = array(
			array(
				"columnName" => "NRORG",
				"operator" => "=",
				"value" => $this->environment->getNrOrg()
			),
			array(
				"columnName" => "CDOPERADOR",
				"operator" => "=",
				"value" => $this->environment->getCdOperador()
			)
		);
		return $this->crudService->getFilteredDataSet("paramoperador", $conditions);
	}
}